#!/bin/sh

VERSION=1.0.0ern

if [ "$1" = "cross" ]; then
    export CROSSCOMPILE=/opt/Embedix/tools
    export QPEDIR=/opt/Qtopia/sharp
    export QTDIR=/opt/Qtopia/sharp
    export PATH=$QTDIR/bin:$QPEDIR/bin:$CROSSCOMPILE/bin:$PATH
    export TMAKEPATH=/opt/Qtopia/tmake/lib/qws/linux-sharp-g++/
    export LD_LIBRARY_PATH=$QTDIR/lib:$LD_LIBRARY_PATH
    export ARCHITECTURE=arm
elif [ "$1" = "native" ]; then
    export CROSSCOMPILE=
    export QPEDIR=/opt/Qtopia
    export QTDIR=/opt/Qtopia
    export PATH=$QTDIR/bin:$QPEDIR/bin:$PATH:/opt/Embedix/tools/bin
    export TMAKEPATH=/opt/Qtopia/tmake/lib/qws/linux-x86-g++/
    export LD_LIBRARY_PATH=$QTDIR/lib:$LD_LIBRARY_PATH
    export ARCHITECTURE=x86
else
    echo "usage: $0 cross | native"
    exit 1
fi

tmake -o Makefile zsubhunt.pro
make
lrelease zsubhunt.pro

for LANGUAGE in en de; do
    mkdir -p tmp/CONTROL
    mkdir -p tmp/opt/QtPalmtop/apps/Games
    mkdir -p tmp/opt/QtPalmtop/bin
    mkdir -p tmp/opt/QtPalmtop/pics/zsubhunt
    if [ "$LANGUAGE" != "en" ]; then
	mkdir -p tmp/opt/QtPalmtop/i18n/${LANGUAGE}
    fi
    cp zsubhunt.desktop tmp/opt/QtPalmtop/apps/Games
    cp zsubhunt tmp/opt/QtPalmtop/bin
    cp pics/*.png tmp/opt/QtPalmtop/pics/zsubhunt
    if [ "$LANGUAGE" != "en" ]; then
	cp i18n/${LANGUAGE}/zsubhunt.qm tmp/opt/QtPalmtop/i18n/${LANGUAGE}
    fi
    cat > tmp/CONTROL/control <<END
Version: ${VERSION}
Depends: qpe-base (\$QPE_VERSION)
Priority: optional
Section: Games
Maintainer: Robert Ernst <robert.ernst@linux-solutions.at>
Architecture: ${ARCHITECTURE}
License: GPL
Description: zSubhunt
 A submarine hunting game.
END
    if [ "$LANGUAGE" != "en" ]; then
	cat >> tmp/CONTROL/control <<END
Package: zsubhunt-${LANGUAGE}
Files: bin/zsubhunt apps/Games/zsubhunt.desktop pics/zsubhunt.png
Filename: ./zsubhunt-${LANGUAGE}_${VERSION}_${ARCHITECTURE}.ipk
END
    else
	cat >> tmp/CONTROL/control <<END
Package: zsubhunt
Files: bin/zsubhunt apps/Games/zsubhunt.desktop pics/zsubhunt.png
Filename: ./zsubhunt_${VERSION}_${ARCHITECTURE}.ipk
END
    fi
    ipkg-build tmp
    rm -rf tmp
done

